//----------------------------------------------------------------------
// penny.js
// Author: Bob Dondero
//----------------------------------------------------------------------

// Omit handling of server-side errors.

const express = require('express');
const database = require('./database');

//----------------------------------------------------------------------

function index(req, res) {
   process.stdout.write(req.originalUrl + '\n');
   res.sendFile('index.html', {root: __dirname},
      (err) => { res.end(); if (err) throw(err); }
   );
}

//----------------------------------------------------------------------

function searchResults(req, res) {
   function handleBooks(err, books) {  // Error handling omitted
      res.setHeader('Content-Type', 'application/json');
      res.end(JSON.stringify(books));
   }

   process.stdout.write(req.originalUrl + '\n');

   let author = req.query.author;
   if (! author)
      author = '';
   author = author.trim();

   if (author === '') {
      res.setHeader('Content-Type', 'application/json');
      res.end(JSON.stringify([]));
   }
   else
      database.getBooks(author, handleBooks);
}

//----------------------------------------------------------------------

let app = express();
app.set('view engine', 'html');
app.set('views', '.');

app.get('/', index);
app.get('/index', index);
app.get('/searchresults', searchResults);

module.exports = { app };
