//----------------------------------------------------------------------
// SearchResultsServlet.java
// Author: Bob Dondero
//----------------------------------------------------------------------

package edu.princeton.penny;

import java.io.PrintWriter;
import java.io.IOException;
import java.util.ArrayList;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import com.google.gson.Gson;

public class SearchResultsServlet extends HttpServlet
{
   protected void doGet(HttpServletRequest request,
      HttpServletResponse response)
      throws ServletException, IOException
   {
      ArrayList<Book> books;

      String author = request.getParameter("author");
      if (author == null)
         author = "";
      author = author.trim();

      if (author.equals(""))
         books = new ArrayList<Book>();
      else
         try
         {
            books = Database.getBooks(author);
         }
         catch (Exception e)
         {
            // Database exception handling omitted.
            return;
         }

      String jsonStr = new Gson().toJson(books);
      PrintWriter out = response.getWriter();
      response.setContentType("application/json");
      response.setCharacterEncoding("UTF-8");
      out.print(jsonStr);
      out.flush();
   }
}
